Properties Methods Events Direct Link

# Class Ext

Package: | Global
Defined In: | Ext.js
Class: | Ext
Extends: | Object

Ext core utilities and functions.
This class is a singleton and cannot be created directly.

## Public Properties

Property | Defined By
--- | ---
| : Object Removes a DOM node from the document. | Ext

BLANK_IMAGE_URL : String
URL to a 1x1 transparent gif image used by Ext to create inline icons with CSS background images. In older versions o...
URL to a 1x1 transparent gif image used by Ext to create inline icons with CSS background images. In older versions of IE, this defaults to "http://extjs.com/s.gif" and you should change this to a URL on your server. For other browsers it uses an inline data URL.

Ext

| SSL_SECURE_URL : String URL to a blank file used by Ext when in secure mode for iframe src and onReady src to prevent the IE insecure content... URL to a blank file used by Ext when in secure mode for iframe src and onReady src to prevent the IE insecure content warning (`'about:blank'`, except for IE in secure mode, which is `'javascript:""'`). | Ext

USE_NATIVE_JSON : Boolean
Indicates whether to use native browser parsing for JSON methods. This option is ignored if the browser does not supp...
Indicates whether to use native browser parsing for JSON methods. This option is ignored if the browser does not support native JSON methods. Note: Native JSON methods will not work with objects that have functions. Also, property names must be quoted, otherwise the data will not parse. (Defaults to false)

Ext

| emptyFn : Function A reusable empty function | Ext
| enableForcedBoxModel : Boolean HIGHLY EXPERIMENTAL True to force css based border-box model override and turning off javascript based adjustments. T... HIGHLY EXPERIMENTAL True to force css based border-box model override and turning off javascript based adjustments. This is a runtime configuration and must be set before onReady. | Ext
| enableFx : Boolean True if the Ext.Fx Class is available | Ext
| enableGarbageCollector : Boolean True to automatically uncache orphaned Ext.Elements periodically (defaults to true) | Ext
| enableListenerCollection : Boolean True to automatically purge event listeners during garbageCollection (defaults to false). | Ext
| enableNestedListenerRemoval : Boolean EXPERIMENTAL - True to cascade listener removal to child elements when an element is removed. Currently not optimized... EXPERIMENTAL - True to cascade listener removal to child elements when an element is removed. Currently not optimized for performance. | Ext
| isAir : Boolean True if the detected platform is Adobe Air. | Ext
| isBorderBox : Boolean True if the detected browser is Internet Explorer running in non-strict mode. | Ext
| isChrome : Boolean True if the detected browser is Chrome. | Ext
| isGecko : Boolean True if the detected browser uses the Gecko layout engine (e.g. Mozilla, Firefox). | Ext
| isGecko2 : Boolean True if the detected browser uses a pre-Gecko 1.9 layout engine (e.g. Firefox 2.x). | Ext
| isGecko3 : Boolean True if the detected browser uses a Gecko 1.9+ layout engine (e.g. Firefox 3.x). | Ext
| isIE : Boolean True if the detected browser is Internet Explorer. | Ext
| isIE6 : Boolean True if the detected browser is Internet Explorer 6.x. | Ext
| isIE7 : Boolean True if the detected browser is Internet Explorer 7.x. | Ext
| isIE8 : Boolean True if the detected browser is Internet Explorer 8.x. | Ext
| isLinux : Boolean True if the detected platform is Linux. | Ext
| isMac : Boolean True if the detected platform is Mac OS. | Ext
| isOpera : Boolean True if the detected browser is Opera. | Ext
| isReady : Boolean True when the document is fully initialized and ready for action | Ext
| isSafari : Boolean True if the detected browser is Safari. | Ext
| isSafari2 : Boolean True if the detected browser is Safari 2.x. | Ext
| isSafari3 : Boolean True if the detected browser is Safari 3.x. | Ext
| isSafari4 : Boolean True if the detected browser is Safari 4.x. | Ext
| isSecure : Boolean True if the page is running over SSL | Ext
| isStrict : Boolean True if the browser is in strict (standards-compliant) mode, as opposed to quirks mode | Ext
| isWebKit : Boolean True if the detected browser uses WebKit. | Ext
| isWindows : Boolean True if the detected platform is Windows. | Ext
| useShims : Boolean By default, Ext intelligently decides whether floating elements should be shimmed. If you are using flash, you may wa... By default, Ext intelligently decides whether floating elements should be shimmed. If you are using flash, you may want to set this to true. | Ext
| ux : Object Namespace alloted for extensions to the framework. | Ext
| version : String The version of the framework | Ext

## Public Methods

Method | Defined By
--- | ---

addBehaviors( `Object obj` ) : void
Applies event listeners to elements by selectors when the document is ready. The event name is specified with an &#64...
Applies event listeners to elements by selectors when the document is ready. The event name is specified with an `@` suffix.

    Ext.addBehaviors({
        // add a listener for click on all anchors in element with id foo
        '#foo a@click' : function(e, t){
            // do something
        },

        // add the same listener to multiple selectors (separated by comma BEFORE the @)
        '#foo a, #bar span.some-class@mouseover' : function(){
            // do something
        }
    });

Parameters:

- `obj` : Object
  The list of behaviors to apply

Returns:

- void

Ext

apply( `Object obj`, `Object config`, `Object defaults` ) : Object
Copies all the properties of config to obj.
Copies all the properties of config to obj.
Parameters:

- `obj` : Object
  The receiver of the properties
- `config` : Object
  The source of the properties
- `defaults` : Object
  A different object that will also be applied for default values

Returns:

- `Object`
  returns obj

Ext

applyIf( `Object obj`, `Object config` ) : Object
Copies all the properties of config to obj if they don't already exist.
Copies all the properties of config to obj if they don't already exist.
Parameters:

- `obj` : Object
  The receiver of the properties
- `config` : Object
  The source of the properties

Returns:

- `Object`
  returns obj

Ext

clean( `Array/NodeList arr` ) : Array
Creates a copy of the passed Array with falsy values removed.
Creates a copy of the passed Array with falsy values removed.
Parameters:

- `arr` : Array/NodeList
  The Array from which to remove falsy values.

Returns:

- `Array`
  The new, compressed Array.

Ext

copyTo( `Object dest`, `Object source`, `Array/String names` ) : Object
Copies a set of named properties fom the source object to the destination object. example:ImageComponent = Ext.extend...
Copies a set of named properties fom the source object to the destination object.

example:

    ImageComponent = Ext.extend(Ext.BoxComponent, {
        initComponent: function() {
            this.autoEl = { tag: 'img' };
            MyComponent.superclass.initComponent.apply(this, arguments);
            this.initialBox = Ext.copyTo({}, this.initialConfig, 'x,y,width,height');
        }
    });

Parameters:

- `dest` : Object
  The destination object.
- `source` : Object
  The source object.
- `names` : Array/String
  Either an Array of property names, or a comma-delimited list of property names to copy.

Returns:

- `Object`
  The modified object.

Ext

create( `Object config`, `Constructor defaultType` ) : Ext.Component
Shorthand for Ext.ComponentMgr.create Creates a new Component from the specified config object using the config objec...
Shorthand for Ext.ComponentMgr.create Creates a new Component from the specified config object using the config object's xtype to determine the class to instantiate.
Parameters:

- `config` : Object
  A configuration object for the Component you wish to create.
- `defaultType` : Constructor
  The constructor to provide the default Component type if the config object does not contain a `xtype`. (Optional if the config contains a `xtype`).

Returns:

- `Ext.Component`
  The newly instantiated Component.

Ext

decode( `String json`, [`Boolean safe`] ) : Object
Shorthand for Ext.util.JSON.decode
Shorthand for Ext.util.JSON.decode
Parameters:

- `json` : String
  The JSON string
- `safe` : Boolean
  (optional) Whether to return null or throw an exception if the JSON is invalid.

Returns:

- `Object`
  The resulting object

Ext

defer( `Function fn`, [`Object scope`], [`Array args`], [`Boolean/Number appendArgs`] ) : Function
Shorthand for Ext.util.Functions.createDelegate
Shorthand for Ext.util.Functions.createDelegate
Parameters:

- `fn` : Function
  The function to delegate.
- `scope` : Object
  (optional) The scope (`this` reference) in which the function is executed. If omitted, defaults to the browser window.
- `args` : Array
  (optional) Overrides arguments for the call. (Defaults to the arguments passed by the caller)
- `appendArgs` : Boolean/Number
  (optional) if True args are appended to call args instead of overriding, if a number the args are inserted at the specified position

Returns:

- `Function`
  The new function

Ext

destroy( `Mixed arg1`, [`Mixed arg2`], [`Mixed etc...`] ) : void
Attempts to destroy any objects passed to it by removing all event listeners, removing them from the DOM (if applicab...
Attempts to destroy any objects passed to it by removing all event listeners, removing them from the DOM (if applicable) and calling their destroy functions (if available). This method is primarily intended for arguments of type Ext.Element and Ext.Component, but any subclass of Ext.util.Observable can be passed in. Any number of elements and/or components can be passed into this function in a single call as separate arguments.
Parameters:

- `arg1` : Mixed
  An Ext.Element, Ext.Component, or an Array of either of these to destroy
- `arg2` : Mixed
  (optional)
- `etc...` : Mixed
  (optional)

Returns:

- void

Ext

destroyMembers( `Object o`, `Mixed arg1`, `Mixed etc...` ) : void
Attempts to destroy and then remove a set of named properties of the passed object.
Attempts to destroy and then remove a set of named properties of the passed object.
Parameters:

- `o` : Object
  The object (most likely a Component) who's properties you wish to destroy.
- `arg1` : Mixed
  The name of the property to destroy and remove from the object.
- `etc...` : Mixed
  More property names to destroy and remove.

Returns:

- void

Ext

each( `Array/NodeList/Mixed array`, `Function fn`, `Object scope` ) : See
Iterates an array calling the supplied function.
Iterates an array calling the supplied function.
Parameters:

- `array` : Array/NodeList/Mixed
  The array to be iterated. If this argument is not really an array, the supplied function is called once.
- `fn` : Function
  The function to be called with each item. If the supplied function returns false, iteration stops and this method returns the current `index`. This function is called with the following arguments:
  - `item` : Mixed
    The item at the current `index` in the passed `array`
  - `index` : Number
    The current index within the array
  - `allItems` : Array
    The `array` passed as the first argument to `Ext.each`.
- `scope` : Object
  The scope (`this` reference) in which the specified function is executed. Defaults to the `item` at the current `index` within the passed `array`.

Returns:

- `See`
  description for the fn parameter.

Ext

encode( `Mixed o` ) : String
Shorthand for Ext.util.JSON.encode
Shorthand for Ext.util.JSON.encode
Parameters:

- `o` : Mixed
  The variable to encode

Returns:

- `String`
  The JSON string

Ext

escapeRe( `String str` ) : String
Escapes the passed string for use in a regular expression
Escapes the passed string for use in a regular expression
Parameters:

- `str` : String

Returns:

- `String`

Ext

extend( `Function superclass`, `Object overrides` ) : Function
Extends one class to create a subclass and optionally overrides members with the passed literal. This method also add...

Extends one class to create a subclass and optionally overrides members with the passed literal. This method also adds the function "override()" to the subclass that can be used to override members of the class.

For example, to create a subclass of Ext GridPanel:

    MyGridPanel = Ext.extend(Ext.grid.GridPanel, {
        constructor: function(config) {

    //      Create configuration for this Grid.
            var store = new Ext.data.Store({...});
            var colModel = new Ext.grid.ColumnModel({...});

    //      Create a new config object containing our computed properties
    //      *plus* whatever was in the config parameter.
            config = Ext.apply({
                store: store,
                colModel: colModel
            }, config);

            MyGridPanel.superclass.constructor.call(this, config);

    //      Your postprocessing here
        },

        yourMethod: function() {
            // etc.
        }
    });

This function also supports a 3-argument call in which the subclass's constructor is passed as an argument. In this form, the parameters are as follows:

- `subclass` : Function
  The subclass constructor.
- `superclass` : Function
  The constructor of class being extended
- `overrides` : Object
  A literal with members which are copied into the subclass's prototype, and are therefore shared among all instances of the new class.

Parameters:

- `superclass` : Function
  The constructor of class being extended.
- `overrides` : Object

  A literal with members which are copied into the subclass's prototype, and are therefore shared between all instances of the new class.

  This may contain a special member named `constructor`. This is used to define the constructor of the new class, and is returned. If this property is not specified, a constructor is generated and returned which just calls the superclass's constructor passing on its parameters.

  It is essential that you call the superclass constructor in any provided constructor. See example code.

Returns:

- `Function`
  The subclass constructor from the <code>overrides</code> parameter, or a generated one if not provided.

Ext

flatten( `Array arr` ) : Array
Recursively flattens into 1-d Array. Injects Arrays inline.
Recursively flattens into 1-d Array. Injects Arrays inline.
Parameters:

- `arr` : Array
  The array to flatten

Returns:

- `Array`
  The new, flattened array.

Ext

fly( `String/HTMLElement el`, [`String named`] ) : Element
Gets the globally shared flyweight Element, with the passed node as the active element. Do not store a reference to t...

Gets the globally shared flyweight Element, with the passed node as the active element. Do not store a reference to this element - the dom node can be overwritten by other code. Shorthand of Ext.Element.fly

Use this to make one-time references to DOM elements which are not going to be accessed again either by application code, or by Ext's classes. If accessing an element which will be processed regularly, then Ext.get will be more appropriate to take advantage of the caching provided by the Ext.Element class.

Parameters:

- `el` : String/HTMLElement
  The dom node or id
- `named` : String
  (optional) Allows for creation of named reusable flyweights to prevent conflicts (e.g. internally Ext uses "_global")

Returns:

- `Element`
  The shared Element object (or null if no matching element was found)

Ext

get( `Mixed el` ) : Element
Retrieves Ext.Element objects. This method does not retrieve Components. This method retrieves Ext.Element objects wh...
Retrieves Ext.Element objects.

This method does not retrieve Components. This method retrieves Ext.Element objects which encapsulate DOM elements. To retrieve a Component by its ID, use Ext.ComponentMgr.get.

Uses simple caching to consistently return the same object. Automatically fixes if an object was recreated with the same id via AJAX or DOM.

Shorthand of Ext.Element.get
Parameters:

- `el` : Mixed
  The id of the node, a DOM Node or an existing Element.

Returns:

- `Element`
  The Element object (or null if no matching element was found)

Ext

getBody() : Ext.Element
Returns the current document body as an Ext.Element.
Returns the current document body as an Ext.Element.
Parameters:

- None.

Returns:

- `Ext.Element`
  The document body

Ext

getCmp( `String id` ) : Ext.Component
This is shorthand reference to Ext.ComponentMgr.get. Looks up an existing Component by id
This is shorthand reference to Ext.ComponentMgr.get. Looks up an existing Component by id
Parameters:

- `id` : String
  The component id

Returns:

- `Ext.Component`
  The Component, <tt>undefined</tt> if not found, or <tt>null</tt> if a Class was found.

Ext

getDoc() : Ext.Element
Returns the current HTML document object as an Ext.Element.
Returns the current HTML document object as an Ext.Element.
Parameters:

- None.

Returns:

- `Ext.Element`
  The document

Ext

getDom( `Mixed el` ) : HTMLElement
Return the dom node for the passed String (id), dom node, or Ext.Element. Optional 'strict' flag is needed for IE sin...
Return the dom node for the passed String (id), dom node, or Ext.Element. Optional 'strict' flag is needed for IE since it can return 'name' and 'id' elements by using getElementById. Here are some examples:

    // gets dom node based on id
    var elDom = Ext.getDom('elId');
    // gets dom node based on the dom node
    var elDom1 = Ext.getDom(elDom);

    // If we don't know if we are working with an
    // Ext.Element or a dom node use Ext.getDom
    function(el){
        var dom = Ext.getDom(el);
        // do something with the dom node
    }

Note: the dom node to be found actually needs to exist (be rendered, etc) when this method is called to be successful.
Parameters:

- `el` : Mixed

Returns:

- `HTMLElement`

Ext

getHead() : Ext.Element
Returns the current document body as an Ext.Element.
Returns the current document body as an Ext.Element.
Parameters:

- None.

Returns:

- `Ext.Element`
  The document body

Ext

getScrollBarWidth( [`Boolean force`] ) : Number
Utility method for getting the width of the browser scrollbar. This can differ depending on operating system settings...
Utility method for getting the width of the browser scrollbar. This can differ depending on operating system settings, such as the theme or font size.
Parameters:

- `force` : Boolean
  (optional) true to force a recalculation of the value.

Returns:

- `Number`
  The width of the scrollbar.

Ext

id( [`Mixed el`], [`String prefix`] ) : String
Generates unique ids. If the element already has an id, it is unchanged
Generates unique ids. If the element already has an id, it is unchanged
Parameters:

- `el` : Mixed
  (optional) The element to generate an id for
- `prefix` : String
  (optional) Id prefix (defaults "ext-gen")

Returns:

- `String`
  The generated Id.

Ext

invoke( `Array|NodeList arr`, `String methodName`, `...* args` ) : Array
Invokes a method on each item in an Array. // Example: Ext.invoke(Ext.query("p"), "getAttribute", "id"); // [el1.getA...
Invokes a method on each item in an Array.

    // Example:
    Ext.invoke(Ext.query("p"), "getAttribute", "id");
    // [el1.getAttribute("id"), el2.getAttribute("id"), ..., elN.getAttribute("id")]

Parameters:

- `arr` : Array|NodeList
  The Array of items to invoke the method on.
- `methodName` : String
  The method name to invoke.
- `args` : ...*
  Arguments to send into the method invocation.

Returns:

- `Array`
  The results of invoking the method on each item in the array.

Ext

isArray( `Mixed value` ) : Boolean
Returns true if the passed value is a JavaScript array, otherwise false.
Returns true if the passed value is a JavaScript array, otherwise false.
Parameters:

- `value` : Mixed
  The value to test

Returns:

- `Boolean`

Ext

isBoolean( `Mixed value` ) : Boolean
Returns true if the passed value is a boolean.
Returns true if the passed value is a boolean.
Parameters:

- `value` : Mixed
  The value to test

Returns:

- `Boolean`

Ext

isDate( `Object object` ) : Boolean
Returns true if the passed object is a JavaScript date object, otherwise false.
Returns true if the passed object is a JavaScript date object, otherwise false.
Parameters:

- `object` : Object
  The object to test

Returns:

- `Boolean`

Ext

isDefined( `Mixed value` ) : Boolean
Returns true if the passed value is not undefined.
Returns true if the passed value is not undefined.
Parameters:

- `value` : Mixed
  The value to test

Returns:

- `Boolean`

Ext

isElement( `Mixed value` ) : Boolean
Returns true if the passed value is an HTMLElement
Returns true if the passed value is an HTMLElement
Parameters:

- `value` : Mixed
  The value to test

Returns:

- `Boolean`

Ext

isEmpty( `Mixed value`, [`Boolean allowBlank`] ) : Boolean
Returns true if the passed value is empty. The value is deemed to be empty if it is<div class="mdetail-params"> null ...

Returns true if the passed value is empty.

The value is deemed to be empty if it is

- null
- undefined
- an empty array
- a zero length string (Unless the `allowBlank` parameter is `true`)

Parameters:

- `value` : Mixed
  The value to test
- `allowBlank` : Boolean
  (optional) true to allow empty strings (defaults to false)

Returns:

- `Boolean`

Ext

isFunction( `Mixed value` ) : Boolean
Returns true if the passed value is a JavaScript Function, otherwise false.
Returns true if the passed value is a JavaScript Function, otherwise false.
Parameters:

- `value` : Mixed
  The value to test

Returns:

- `Boolean`

Ext

isNumber( `Mixed value` ) : Boolean
Returns true if the passed value is a number. Returns false for non-finite numbers.
Returns true if the passed value is a number. Returns false for non-finite numbers.
Parameters:

- `value` : Mixed
  The value to test

Returns:

- `Boolean`

Ext

isObject( `Mixed value` ) : Boolean
Returns true if the passed value is a JavaScript Object, otherwise false.
Returns true if the passed value is a JavaScript Object, otherwise false.
Parameters:

- `value` : Mixed
  The value to test

Returns:

- `Boolean`

Ext

isPrimitive( `Mixed value` ) : Boolean
Returns true if the passed value is a JavaScript 'primitive', a string, number or boolean.
Returns true if the passed value is a JavaScript 'primitive', a string, number or boolean.
Parameters:

- `value` : Mixed
  The value to test

Returns:

- `Boolean`

Ext

isString( `Mixed value` ) : Boolean
Returns true if the passed value is a string.
Returns true if the passed value is a string.
Parameters:

- `value` : Mixed
  The value to test

Returns:

- `Boolean`

Ext

iterate( `Object/Array object`, `Function fn`, `Object scope` ) : void
Iterates either the elements in an array, or each of the properties in an object. Note: If you are only iterating arr...
Iterates either the elements in an array, or each of the properties in an object. Note: If you are only iterating arrays, it is better to call each.
Parameters:

- `object` : Object/Array
  The object or array to be iterated
- `fn` : Function
  The function to be called for each iteration. The iteration will stop if the supplied function returns false, or all array elements / object properties have been covered. The signature varies depending on the type of object being interated:
  - Arrays : `(Object item, Number index, Array allItems)`
    When iterating an array, the supplied function is called with each item.
  - Objects : `(String key, Object value, Object)`
    When iterating an object, the supplied function is called with each key-value pair in the object, and the iterated object
- `scope` : Object
  The scope (`this` reference) in which the specified function is executed. Defaults to the `object` being iterated.

Returns:

- void

Ext

max( `Array|NodeList arr`, [`Function comp`] ) : Object
Returns the maximum value in the Array
Returns the maximum value in the Array
Parameters:

- `arr` : Array|NodeList
  The Array from which to select the maximum value.
- `comp` : Function
  (optional) a function to perform the comparision which determines maximization. If omitted the ">" operator will be used. Note: gt = 1; eq = 0; lt = -1

Returns:

- `Object`
  The maximum value in the Array.

Ext

mean( `Array arr` ) : Number
Calculates the mean of the Array
Calculates the mean of the Array
Parameters:

- `arr` : Array
  The Array to calculate the mean value of.

Returns:

- `Number`
  The mean.

Ext

min( `Array|NodeList arr`, [`Function comp`] ) : Object
Returns the minimum value in the Array.
Returns the minimum value in the Array.
Parameters:

- `arr` : Array|NodeList
  The Array from which to select the minimum value.
- `comp` : Function
  (optional) a function to perform the comparision which determines minimization. If omitted the "<" operator will be used. Note: gt = 1; eq = 0; lt = -1

Returns:

- `Object`
  The minimum value in the Array.

Ext

namespace( `String namespace1`, `String namespace2`, `String etc` ) : Object
Creates namespaces to be used for scoping variables and classes so that they are not global. Specifying the last node...
Creates namespaces to be used for scoping variables and classes so that they are not global. Specifying the last node of a namespace implicitly creates all other nodes. Usage:

    Ext.namespace('Company', 'Company.data');
    Ext.namespace('Company.data'); // equivalent and preferable to above syntax
    Company.Widget = function() { ... }
    Company.data.CustomStore = function(config) { ... }

Parameters:

- `namespace1` : String
- `namespace2` : String
- `etc` : String

Returns:

- `Object`
  The namespace object. (If multiple arguments are passed, this will be the last namespace created)

Ext

ns( `String namespace1`, `String namespace2`, `String etc` ) : Object
Creates namespaces to be used for scoping variables and classes so that they are not global. Specifying the last node...
Creates namespaces to be used for scoping variables and classes so that they are not global. Specifying the last node of a namespace implicitly creates all other nodes. Usage:

    Ext.namespace('Company', 'Company.data');
    Ext.namespace('Company.data'); // equivalent and preferable to above syntax
    Company.Widget = function() { ... }
    Company.data.CustomStore = function(config) { ... }

Parameters:

- `namespace1` : String
- `namespace2` : String
- `etc` : String

Returns:

- `Object`
  The namespace object. (If multiple arguments are passed, this will be the last namespace created)

Ext

num( `Mixed value`, `Number defaultValue` ) : Number
Utility method for validating that a value is numeric, returning the specified default value if it is not.
Utility method for validating that a value is numeric, returning the specified default value if it is not.
Parameters:

- `value` : Mixed
  Should be a number, but any type will be handled appropriately
- `defaultValue` : Number
  The value to return if the original value is non-numeric

Returns:

- `Number`
  Value, if numeric, else defaultValue

Ext

onReady( `Function fn`, [`Object scope`], [`boolean options`] ) : void
Adds a listener to be notified when the document is ready (before onload and before images are loaded). Shorthand of ...
Adds a listener to be notified when the document is ready (before onload and before images are loaded). Shorthand of Ext.EventManager.onDocumentReady.
Parameters:

- `fn` : Function
  The method the event invokes.
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function executes. Defaults to the browser window.
- `options` : boolean
  (optional) Options object as passed to Ext.Element.addListener. It is recommended that the options `{single: true}` be used so that the handler is removed on first invocation.

Returns:

- void

Ext

override( `Object origclass`, `Object overrides` ) : void
Adds a list of functions to the prototype of an existing class, overwriting any existing methods with the same name. ...
Adds a list of functions to the prototype of an existing class, overwriting any existing methods with the same name. Usage:

    Ext.override(MyClass, {
        newMethod1: function(){
            // etc.
        },
        newMethod2: function(foo){
            // etc.
        }
    });

Parameters:

- `origclass` : Object
  The class to override
- `overrides` : Object
  The list of functions to add to origClass. This should be specified as an object literal containing one or more methods.

Returns:

- void

Ext

partition( `Array|NodeList arr`, [`Function truth`] ) : Array
Partitions the set into two sets: a true set and a false set. Example: Example2: // Example 1: Ext.partition([true, f...
Partitions the set into two sets: a true set and a false set. Example: Example2:

    // Example 1:
    Ext.partition([true, false, true, true, false]); // [[true, true, true], [false, false]]

    // Example 2:
    Ext.partition(
        Ext.query("p"),
        function(val){
            return val.className == "class1"
        }
    );
    // true are those paragraph elements with a className of "class1",
    // false set are those that do not have that className.

Parameters:

- `arr` : Array|NodeList
  The array to partition
- `truth` : Function
  (optional) a function to determine truth. If this is omitted the element itself must be able to be evaluated for its truthfulness.

Returns:

- `Array`
  [true<Array>,false<Array>]

Ext

pluck( `Array|NodeList arr`, `String prop` ) : Array
Plucks the value of a property from each item in the Array // Example: Ext.pluck(Ext.query("p"), "className"); // [el...
Plucks the value of a property from each item in the Array

    // Example:
    Ext.pluck(Ext.query("p"), "className"); // [el1.className, el2.className, ..., elN.className]

Parameters:

- `arr` : Array|NodeList
  The Array of items to pluck the value from.
- `prop` : String
  The property name to pluck from each element.

Returns:

- `Array`
  The value from each item in the Array.

Ext

preg( `String ptype`, `Constructor cls` ) : void
Shorthand for Ext.ComponentMgr.registerPlugin
Shorthand for Ext.ComponentMgr.registerPlugin
Parameters:

- `ptype` : String
  The mnemonic string by which the Plugin class may be looked up.
- `cls` : Constructor
  The new Plugin class.

Returns:

- void

Ext

query( `String path`, [`Node root`] ) : Array
Selects an array of DOM nodes by CSS/XPath selector. Shorthand of Ext.DomQuery.select
Selects an array of DOM nodes by CSS/XPath selector. Shorthand of Ext.DomQuery.select
Parameters:

- `path` : String
  The selector/xpath query
- `root` : Node
  (optional) The start of the query (defaults to document).

Returns:

- `Array`

Ext

reg( `String xtype`, `Constructor cls` ) : void
Shorthand for Ext.ComponentMgr.registerType
Shorthand for Ext.ComponentMgr.registerType
Parameters:

- `xtype` : String
  The mnemonic string by which the Component class may be looked up.
- `cls` : Constructor
  The new Component class.

Returns:

- void

Ext

removeNode( `HTMLElement node` ) : void
Removes this element from the document, removes all DOM event listeners, and deletes the cache reference. All DOM eve...

Removes this element from the document, removes all DOM event listeners, and deletes the cache reference. All DOM event listeners are removed from this element. If Ext.enableNestedListenerRemoval is `true`, then DOM event listeners are also removed from all child nodes. The body node will be ignored if passed in.

Parameters:

- `node` : HTMLElement
  The node to remove

Returns:

- void

Ext

select( `String/Array selector`, [`Boolean unique`], [`HTMLElement/String root`] ) : CompositeElementLite/CompositeElement
Selects elements based on the passed CSS selector to enable Element methods to be applied to many related elements in...
Selects elements based on the passed CSS selector to enable Element methods to be applied to many related elements in one statement through the returned CompositeElement or CompositeElementLite object.
Parameters:

- `selector` : String/Array
  The CSS selector or an array of elements
- `unique` : Boolean
  (optional) true to create a unique Ext.Element for each element (defaults to a shared flyweight object)
- `root` : HTMLElement/String
  (optional) The root element of the query or id of the root

Returns:

- `CompositeElementLite/CompositeElement`

Ext

sum( `Array arr` ) : Number
Calculates the sum of the Array
Calculates the sum of the Array
Parameters:

- `arr` : Array
  The Array to calculate the sum value of.

Returns:

- `Number`
  The sum.

Ext

toArray( `Iterable the` ) : (Array)
Converts any iterable (numeric indices and a length property) into a true array Don't use this on strings. IE doesn't...
Converts any iterable (numeric indices and a length property) into a true array Don't use this on strings. IE doesn't support "abc"[0] which this implementation depends on. For strings, use this instead: "abc".match(/./g) => [a,b,c];
Parameters:

- `the` : Iterable
  iterable object to be turned into a true Array.

Returns:

- `(Array)`
  array

Ext

type( `Mixed object` ) : String
Returns the type of object that is passed in. If the object passed in is null or undefined it return false otherwise ...
Returns the type of object that is passed in. If the object passed in is null or undefined it return false otherwise it returns one of the following values:

- string: If the object passed is a string
- number: If the object passed is a number
- boolean: If the object passed is a boolean value
- date: If the object passed is a Date object
- function: If the object passed is a function reference
- object: If the object passed is an object
- array: If the object passed is an array
- regexp: If the object passed is a regular expression
- element: If the object passed is a DOM Element
- nodelist: If the object passed is a DOM NodeList
- textnode: If the object passed is a DOM text node and contains something other than whitespace
- whitespace: If the object passed is a DOM text node and contains only whitespace

Parameters:

- `object` : Mixed

Returns:

- `String`

Ext

unique( `Array arr` ) : Array
Creates a copy of the passed Array, filtered to contain only unique values.
Creates a copy of the passed Array, filtered to contain only unique values.
Parameters:

- `arr` : Array
  The Array to filter

Returns:

- `Array`
  The new Array containing unique values.

Ext

urlAppend( `String url`, `String s` ) : (String)
Appends content to the query string of a URL, handling logic for whether to place a question mark or ampersand.
Appends content to the query string of a URL, handling logic for whether to place a question mark or ampersand.
Parameters:

- `url` : String
  The URL to append to.
- `s` : String
  The content to append to the URL.

Returns:

- `(String)`
  The resulting URL

Ext

urlDecode( `String string`, [`Boolean overwrite`] ) : Object
Takes an encoded URL and and converts it to an object. Example: Ext.urlDecode("foo=1&bar=2"); // returns {foo: "1", b...
Takes an encoded URL and and converts it to an object. Example:

    Ext.urlDecode("foo=1&bar=2"); // returns {foo: "1", bar: "2"}
    Ext.urlDecode("foo=1&bar=2&bar=3&bar=4", false); // returns {foo: "1", bar: ["2", "3", "4"]}

Parameters:

- `string` : String
- `overwrite` : Boolean
  (optional) Items of the same name will overwrite previous values instead of creating an an array (Defaults to false).

Returns:

- `Object`
  A literal with members

Ext

urlEncode( `Object o`, [`String pre`] ) : String
Takes an object and converts it to an encoded URL. e.g. Ext.urlEncode({foo: 1, bar: 2}); would return "foo=1&bar=2". ...
Takes an object and converts it to an encoded URL. e.g. Ext.urlEncode({foo: 1, bar: 2}); would return "foo=1&bar=2". Optionally, property values can be arrays, instead of keys and the resulting string that's returned will contain a name/value pair for each array value.
Parameters:

- `o` : Object
- `pre` : String
  (optional) A prefix to add to the url encoded string

Returns:

- `String`

Ext

value( `Mixed value`, `Mixed defaultValue`, [`Boolean allowBlank`] ) : Mixed
Utility method for returning a default value if the passed value is empty. The value is deemed to be empty if it is<d...

Utility method for returning a default value if the passed value is empty.

The value is deemed to be empty if it is

- null
- undefined
- an empty array
- a zero length string (Unless the `allowBlank` parameter is `true`)

Parameters:

- `value` : Mixed
  The value to test
- `defaultValue` : Mixed
  The value to return if the original value is empty
- `allowBlank` : Boolean
  (optional) true to allow zero length strings to qualify as non-empty (defaults to false)

Returns:

- `Mixed`
  value, if non-empty, else defaultValue

Ext

zip( `Arrays|NodeLists arr`, [`Function zipper`] ) : Array
Zips N sets together. // Example 1: Ext.zip([1,2,3],[4,5,6]); // [[1,4],[2,5],[3,6]] // Example 2: Ext.zip( [ "+"...

Zips N sets together.

    // Example 1:
    Ext.zip([1,2,3],[4,5,6]); // [[1,4],[2,5],[3,6]]
    // Example 2:
    Ext.zip(
        [ "+", "-", "+"],
        [  12,  10,  22],
        [  43,  15,  96],
        function(a, b, c){
            return "$" + a + "" + b + "." + c
        }
    ); // ["$+12.43", "$-10.15", "$+22.96"]

Parameters:

- `arr` : Arrays|NodeLists
  This argument may be repeated. Array(s) to contribute values.
- `zipper` : Function
  (optional) The last item in the argument list. This will drive how the items are zipped together.

Returns:

- `Array`
  The zipped set.

Ext

## Public Events

This class has no public events.